# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

#### Public Classes

* [`auditd`](#auditd): audit daemon

#### Private Classes

* `auditd::config`: auditd configuration
* `auditd::package`: auditd package management
* `auditd::service`: auditd service management

### Defined types

* [`auditd::rule`](#auditdrule): Creates auditd rules

### Data types

* [`Auditd::Conf`](#auditdconf): auditd.conf configuration file parameters
* [`Auditd::Rules`](#auditdrules): auditd rule parameters

## Classes

### <a name="auditd"></a>`auditd`

audit daemon

#### Parameters

The following parameters are available in the `auditd` class:

* [`package_name`](#package_name)
* [`package_ensure`](#package_ensure)
* [`service_enable`](#service_enable)
* [`service_name`](#service_name)
* [`rules`](#rules)
* [`rules_file`](#rules_file)
* [`config`](#config)
* [`buffer_size`](#buffer_size)
* [`failure_mode`](#failure_mode)
* [`immutable`](#immutable)
* [`syslog_output`](#syslog_output)
* [`service_ensure`](#service_ensure)

##### <a name="package_name"></a>`package_name`

Data type: `String[1]`

The package name to use

Default value: `'auditd'`

##### <a name="package_ensure"></a>`package_ensure`

Data type: `String`

The package state to set

Default value: `'installed'`

##### <a name="service_enable"></a>`service_enable`

Data type: `Boolean`

The service enable state

Default value: ``true``

##### <a name="service_name"></a>`service_name`

Data type: `String[1]`

The service name to use

Default value: `'auditd'`

##### <a name="rules"></a>`rules`

Data type: `Optional[Hash[String, Auditd::Rules]]`

Hash of auditd rules to set

Default value: `{}`

##### <a name="rules_file"></a>`rules_file`

Data type: `Stdlib::Absolutepath`

The rules file to use

Default value: `'/etc/audit/rules.d/audit.rules'`

##### <a name="config"></a>`config`

Data type: `Auditd::Conf`

auditd.conf configuration hash

Default value: `{}`

##### <a name="buffer_size"></a>`buffer_size`

Data type: `Integer`

The buffer size to use

Default value: `8192`

##### <a name="failure_mode"></a>`failure_mode`

Data type: `Integer`

The failure mode (defaults to printing failure message)

Default value: `1`

##### <a name="immutable"></a>`immutable`

Data type: `Boolean`

Make the configuration immutable

Default value: ``false``

##### <a name="syslog_output"></a>`syslog_output`

Data type: `Boolean`

Enable syslog output

Default value: ``true``

##### <a name="service_ensure"></a>`service_ensure`

Data type: `Stdlib::Ensure::Service`



Default value: `'running'`

## Defined types

### <a name="auditdrule"></a>`auditd::rule`

Creates auditd rules

#### Parameters

The following parameters are available in the `auditd::rule` defined type:

* [`content`](#content)
* [`order`](#order)

##### <a name="content"></a>`content`

Data type: `String`

The rule content

Default value: `''`

##### <a name="order"></a>`order`

Data type: `Integer[1, 100]`

The rule priority order (between 1 and 100)

Default value: `10`

## Data types

### <a name="auditdconf"></a>`Auditd::Conf`

auditd.conf configuration file parameters

Alias of

```puppet
Struct[{
    Optional['local_events']            => Enum['yes', 'no'],
    Optional['log_file']                => Stdlib::Absolutepath,
    Optional['write_logs']              => Enum['yes', 'no'],
    Optional['log_format']              => Enum[
      'raw', 'RAW',
      'enriched', 'ENRICHED',
    ],
    Optional['log_group']               => Variant[Integer, String[1]],
    Optional['priority_boost']          => Integer[0],
    Optional['flush']                   => Enum[
      'none', 'NONE',
      'incremental', 'INCREMENTAL',
      'incremental_async', 'INCREMENTAL_ASYNC',
      'data', 'DATA',
      'sync', 'SYNC',
    ],
    Optional['freq']                    => Integer[0],
    Optional['dispatcher']              => String,
    Optional['disp_qos']                => Enum[
      'lossy', 'LOSSY',
      'lossless', 'LOSSLESS'
    ],
    Optional['num_logs']                => Integer[0, 999],
    Optional['name_format']             => Enum[
      'none', 'NONE',
      'hostname', 'HOSTNAME',
      'fqd', 'FQD',
      'numeric', 'NUMERIC',
      'user', 'USER',
    ],
    Optional['name']                    => String,
    Optional['max_log_file']            => Integer,
    Optional['max_log_file_action']     => Enum[
      'ignore', 'IGNORE',
      'syslog', 'SYSLOG',
      'suspend', 'SUSPEND',
      'rotate', 'ROTATE',
      'keep_logs', 'KEEP_LOGS',
    ],
    Optional['verify_email']            => Enum['yes', 'no'],
    Optional['action_mail_acct']        => Variant[String, Stdlib::Email],
    Optional['space_left']              => Integer,
    Optional['space_left_action']       => Enum[
      'ignore', 'IGNORE',
      'syslog', 'SYSLOG',
      'rotate', 'ROTATE',
      'email', 'EMAIL',
      'exec', 'EXEC',
      'suspend', 'SUSPEND',
      'single', 'SINGLE',
      'halt', 'HALT',
    ],
    Optional['admin_space_left']        => Variant[Integer, String],
    Optional['admin_space_left_action'] => Enum[
      'ignore', 'IGNORE',
      'syslog', 'SYSLOG',
      'rotate', 'ROTATE',
      'email', 'EMAIL',
      'exec', 'EXEC',
      'suspend', 'SUSPEND',
      'single', 'SINGLE',
      'halt', 'HALT',
    ],
    Optional['disk_full_action']        => Enum[
      'ignore', 'IGNORE',
      'syslog', 'SYSLOG',
      'rotate', 'ROTATE',
      'exec', 'EXEC',
      'suspend', 'SUSPEND',
      'single', 'SINGLE',
      'halt', 'HALT',
    ],
    Optional['disk_error_action']       => Enum[
      'ignore', 'IGNORE',
      'syslog', 'SYSLOG',
      'exec', 'EXEC',
      'suspend', 'SUSPEND',
      'single', 'SINGLE',
      'halt', 'HALT',
    ],
    Optional['tcp_listen_port']         => Integer[1,65535],
    Optional['tcp_listen_queue']        => Integer,
    Optional['tcp_max_per_addr']        => Integer[1,1024],
    Optional['use_libwrap']             => Enum['yes', 'no'],
    Optional['tcp_client_ports']        => Variant[Integer, String],
    Optional['tcp_client_max_idle']     => Integer,
    Optional['transport']               => Enum['tcp', 'TCP', 'krb5', 'KRB5'],
    Optional['enable_krb5']             => Enum['yes', 'no'],
    Optional['krb5_principal']          => String,
    Optional['krb5_key_file']           => Stdlib::Absolutepath,
    Optional['distribute_network']      => Enum['yes', 'no'],
    Optional['q_depth']                 => Integer,
    Optional['overflow_action']         => Enum[
      'ignore', 'IGNORE',
      'syslog', 'SYSLOG',
      'suspend', 'SUSPEND',
      'single', 'SINGLE',
      'halt', 'HALT',
    ],
    Optional['max_restarts']            => Integer[0],
    Optional['plugin_dir']              => Stdlib::Absolutepath,
    Optional['end_of_event_timeout']    => Integer[0],
  }]
```

### <a name="auditdrules"></a>`Auditd::Rules`

auditd rule parameters

Alias of

```puppet
Struct[{
    Optional['content'] => String,
    Optional['order']   => Integer[1, 99],
  }]
```

